/* jshint node: true */

var webpack = require('webpack');

module.exports = {
    output: {
        sourcePrefix: '    ',
        devtoolModuleFilenameTemplate: "devextreme:///[resource-path]",
        devtoolFallbackModuleFilenameTemplate: "devextreme:///[resource-path]?[hash]"
    },
    externals: {
        // Required
        'jquery': 'jQuery',
        // Optional (calling through window to skip error on script load)
        'jszip': 'window.JSZip',
        'knockout': 'window.ko',
        'globalize': 'window.Globalize',
        'globalize/number': 'window.Globalize',
        'globalize/currency': 'window.Globalize',
        'globalize/date': 'window.Globalize',
        'globalize/message': 'window.Globalize'
    },
    plugins: [
        new webpack.optimize.OccurrenceOrderPlugin(true)
    ]
};