/** 
 * DevExtreme (core/utils/weak_map.js)
 * Version: 16.1.5
 * Build date: Mon Jul 25 2016
 *
 * Copyright (c) 2012 - 2016 Developer Express Inc. ALL RIGHTS RESERVED
 * EULA: https://www.devexpress.com/Support/EULAs/DevExtreme.xml
 * MAY BE USED WITH: DevExtreme Complete, DevExtreme Web, DevExtreme Mobile
 */
"use strict";
define(function(require, exports, module) {
    var $ = require("jquery"),
        WeakMap = window.WeakMap;
    if (!WeakMap) {
        WeakMap = function() {
            var keys = [],
                values = [];
            this.set = function(key, value) {
                var index = $.inArray(key, keys);
                if (-1 === index) {
                    keys.push(key);
                    values.push(value)
                } else {
                    values[index] = value
                }
            };
            this.get = function(key) {
                var index = $.inArray(key, keys);
                if (-1 === index) {
                    return
                }
                return values[index]
            };
            this.has = function(key) {
                var index = $.inArray(key, keys);
                if (-1 === index) {
                    return false
                }
                return true
            }
        }
    }
    module.exports = WeakMap
});
