/** 
 * DevExtreme (ui/widget/ui.template.dynamic.js)
 * Version: 16.1.5
 * Build date: Mon Jul 25 2016
 *
 * Copyright (c) 2012 - 2016 Developer Express Inc. ALL RIGHTS RESERVED
 * EULA: https://www.devexpress.com/Support/EULAs/DevExtreme.xml
 * MAY BE USED WITH: DevExtreme Complete, DevExtreme Web, DevExtreme Mobile
 */
"use strict";
define(function(require, exports, module) {
    var $ = require("jquery"),
        TemplateBase = require("./ui.template_base");
    var DynamicTemplate = TemplateBase.inherit({
        ctor: function(compileFunction, owner) {
            this.callBase($(), owner);
            this._compileFunction = compileFunction
        },
        _renderCore: function(data, index, container) {
            if (void 0 === data && void 0 === index) {
                data = container;
                container = void 0
            }
            var compiledTemplate = void 0 === index ? this._compileFunction(data, container) : this._compileFunction(data, index, container);
            var renderResult = compiledTemplate.render(data, container, index);
            if (compiledTemplate.owner() === this) {
                compiledTemplate.dispose()
            }
            return renderResult
        }
    });
    module.exports = DynamicTemplate
});
